/* Author: Derek O Reilly, Dundalk Institute of Technology, Ireland. */



// assign locations in the body array for each body part
var HEAD = 0;
var TORSO = 1;
var LEFT_ARM_UPPER = 2;
var LEFT_ARM_LOWER = 3;
var LEFT_ARM_HAND = 4;
var RIGHT_ARM_UPPER = 5;
var RIGHT_ARM_LOWER = 6;
var RIGHT_ARM_HAND = 7;
var LEFT_LEG_UPPER = 8;
var LEFT_LEG_LOWER = 9;
var LEFT_LEG_FOOT = 10;
var RIGHT_LEG_UPPER = 11;
var RIGHT_LEG_LOWER = 12;
var RIGHT_LEG_FOOT = 13;

class DancingTeddy extends Teddy
{
    /* Each gameObject MUST have a constructor() and a render() method.        */
    /* If the object animates, then it must also have an updateState() method. */

    constructor(torsoCentreX, torsoCentreY, scale, delay, torsoImage, headImage, leftArmUpperImage, leftArmLowerImage, leftArmHandImage, rightArmUpperImage, rightArmLowerImage, rightArmHandImage, leftLegUpperImage, leftLegLowerImage, leftLegFootImage, rightLegUpperImage, rightLegLowerImage, rightLegFootImage)
    {
        super(torsoCentreX, torsoCentreY, scale, torsoImage, headImage, leftArmUpperImage, leftArmLowerImage, leftArmHandImage, rightArmUpperImage, rightArmLowerImage, rightArmHandImage, leftLegUpperImage, leftLegLowerImage, leftLegFootImage, rightLegUpperImage, rightLegLowerImage, rightLegFootImage, delay); /* as this class extends from GameObject, you must always call super() */
        this.setHotSpotDrawState(false);
        this.degreesStepSize = 4; // used in updateState
    }

    updateState()
    {
        // randomly move some of the DancingTeddy's bodyParts
        let degrees = this.bodyPart[TORSO].getDegrees() + this.degreesStepSize;

        if ((Math.random() * 100 > 90) || (degrees > 90) || (degrees < -90))
        {
            this.degreesStepSize *= -1;
        }

        this.bodyPart[TORSO].setRadiants(this.bodyPart[TORSO].getDegrees() + this.degreesStepSize);
        this.bodyPart[HEAD].setRadiants(this.bodyPart[HEAD].getDegrees() + this.degreesStepSize * -0.1);
        this.bodyPart[LEFT_LEG_UPPER].setRadiants(this.bodyPart[LEFT_LEG_UPPER].getDegrees() + this.degreesStepSize * 1.5);
        this.bodyPart[RIGHT_ARM_UPPER].setRadiants(this.bodyPart[RIGHT_ARM_UPPER].getDegrees() + this.degreesStepSize * 0.75);
        this.bodyPart[LEFT_ARM_UPPER].setRadiants(this.bodyPart[LEFT_ARM_UPPER].getDegrees() + this.degreesStepSize * 0.2);
    }
}